## org.jfree.data.statistics
Class BoxAndWhiskerCalculator

    java.lang.Object
      org.jfree.data.statistics.BoxAndWhiskerCalculator

    public abstract class BoxAndWhiskerCalculator

extends java.lang.Object

A utility class that calculates the mean, median, quartiles Q1 and Q3, plus a list of outlier values...all from an arbitrary list of `Number` objects.

Constructor Summary
`BoxAndWhiskerCalculator()`

Method Summary
`static BoxAndWhiskerItem` `calculateBoxAndWhiskerStatistics(java.util.List values)` Calculates the statistics required for a `BoxAndWhiskerItem` from a list of `Number` objects.
`static BoxAndWhiskerItem` `calculateBoxAndWhiskerStatistics(java.util.List values, boolean stripNullAndNaNItems)` Calculates the statistics required for a `BoxAndWhiskerItem` from a list of `Number` objects.
`static double` `calculateQ1(java.util.List values)` Calculates the first quartile for a list of numbers in ascending order.
`static double` `calculateQ3(java.util.List values)` Calculates the third quartile for a list of numbers in ascending order.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BoxAndWhiskerCalculator

    public BoxAndWhiskerCalculator()

Method Detail

### calculateBoxAndWhiskerStatistics

    public static BoxAndWhiskerItem calculateBoxAndWhiskerStatistics(java.util.List values)

  Calculates the statistics required for a `BoxAndWhiskerItem` from a list of `Number` objects. Any items in the list that are `null`, not an instance of `Number`, or equivalent to `Double.NaN`, will be ignored.

  Parameters:
    `values` - a list of numbers (a `null` list is not permitted).
  Returns:
    A box-and-whisker item.

### calculateBoxAndWhiskerStatistics

    public static BoxAndWhiskerItem calculateBoxAndWhiskerStatistics(java.util.List values,
                                                                     boolean stripNullAndNaNItems)

  Calculates the statistics required for a `BoxAndWhiskerItem` from a list of `Number` objects. Any items in the list that are `null`, not an instance of `Number`, or equivalent to `Double.NaN`, will be ignored.

  Parameters:
    `values` - a list of numbers (a `null` list is not permitted).
    `stripNullAndNaNItems` - a flag that controls the handling of null and NaN items.
  Returns:
    A box-and-whisker item.
  Since:
    1.0.3

### calculateQ1

    public static double calculateQ1(java.util.List values)

  Calculates the first quartile for a list of numbers in ascending order. If the items in the list are not in ascending order, the result is unspecified. If the list contains items that are `null`, not an instance of `Number`, or equivalent to `Double.NaN`, the result is unspecified.

  Parameters:
    `values` - the numbers in ascending order (`null` not permitted).
  Returns:
    The first quartile.

### calculateQ3

    public static double calculateQ3(java.util.List values)

  Calculates the third quartile for a list of numbers in ascending order. If the items in the list are not in ascending order, the result is unspecified. If the list contains items that are `null`, not an instance of `Number`, or equivalent to `Double.NaN`, the result is unspecified.

  Parameters:
    `values` - the list of values (`null` not permitted).
  Returns:
    The third quartile.